﻿# -*- encoding: utf-8 -*-
##############################################################################
#
#	Copyright (C) 2010 Kontaxis Panagiotis
#
#	This program is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import datetime
import time
from report.interface import report_rml
from report.interface import toxml

from tools.translate import _
from osv import osv
import pooler

def lengthmonth(year, month):
	if month == 2 and ((year % 4 == 0) and ((year % 100 != 0) or (year % 400 == 0))):
		return 29
	return [0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31][month]

def emp_create_xml(cr, id, som, eom):
	# Computing the attendence by analytical account
	cr.execute(
		"select line.date, (unit_amount * unit.factor) as amount "\
		"from account_analytic_line as line, hr_analytic_timesheet as hr, "\
		"product_uom as unit "\
		"where hr.line_id=line.id "\
		"and product_uom_id = unit.id "\
		"and line.user_id=%s and line.date >= %s and line.date < %s "
		"order by line.date",
		(id, som.strftime('%Y-%m-%d'), eom.strftime('%Y-%m-%d')))
	
	# Sum by day
	month = {}
	for presence in cr.dictfetchall():
		day = int(presence['date'][-2:])
		month[day] = month.get(day, 0.0) + presence['amount']
	
	xml = '''
	<time-element date="%s">
		<amount>%.2f</amount>
	</time-element>
	'''
	time_xml = ([xml % (day, amount) for day, amount in month.iteritems()])
	#print time_xml
	# Computing the employee
	cr.execute("select name from res_users where id=%s", (id,))
	emp = cr.fetchone()[0]
	
	# Computing the xml
	xml = '''
	<employee id="%d" name="%s">
	%s
	</employee>
	''' % (id, toxml(emp), '\n'.join(time_xml))
	print xml
	return xml

class report_custom(report_rml):

	def get_month_name(self, cr, uid, month):
		_months = {1:_("January"), 2:_("February"), 3:_("March"), 4:_("April"), 5:_("May"), 6:_("June"), 7:_("July"), 8:_("August"), 9:_("September"), 10:_("October"), 11:_("November"), 12:_("December")}
		return _months[month]
	
	def get_weekday_name(self, cr, uid, weekday):
		_weekdays = {1:_('Mon'), 2:_('Tue'), 3:_('Wed'), 4:_('Thu'), 5:_('Fri'), 6:_('Sat'), 7:_('Sun')}
		return _weekdays[weekday]

	def create_xml(self, cr, uid, ids, data, context):
		def dist(seq):
			return dict(zip(seq, [None,]*len(seq))).keys()
		lab_template=data['form']['labtemplate_id']
		#vriskw to partner_id 
		#an data['form']['patient_id'] != null tote to wizard klithike apo to kentriko menou
		#an data['id'] tote to wizard klithike apo to sidebar
		partner_id=data['form']['patient_id'] if data['form']['patient_id'] else data['id']
		startdate=data['form']['startdate'] #datetime.date.today()-datetime.timedelta(days=4)
		enddate=data['form']['enddate'] #datetime.date.today()+datetime.timedelta(days=4)
		#print self.__doc__
		#print data
		
		#Vriskw ta test pou einai endiamesa
		obj = pooler.get_pool(cr.dbname).get('hospital.lab.test')
		print lab_template
		sarray=[('labtemplate_id', '=', lab_template),('patient_id', '=', partner_id)]
		if startdate: sarray.append(('date_analysis', '>', startdate))
		if enddate: sarray.append(('date_analysis', '<', enddate))
		test_ids = obj.search(cr, uid, sarray)
		#print lab_template
		#print enddate
		print test_ids
		tests=obj.browse(cr, uid, test_ids)
		vals=[]
		dates='<days>'
		cols=[]
		cols.append('<cols>7cm') #platos 1is stilis
		for i,t in enumerate(tests):
			print t.date_analysis
			dates+='<day number="%s" name="Mon" weekday="%s" description="%s" />' % (i+1,i+1,str(time.strptime(t.date_analysis[0:10],'%Y-%m-%d')[2])+"/"+str(time.strptime(t.date_analysis[0:10],'%Y-%m-%d')[1]))
			cols.append(1.5)
			dict={}
			for i,l in enumerate(t.lablines_ids):
				dict[l.labelement_id.id]=l.value
			vals.append(dict)
		#print vals
		dates+='</days>'
		cols.append(',2cm,2cm</cols>')
		#vriskw ola ta lines twn test (giati kapoia tests exoun custom extra lines)
		#prepei na brw ola ta extra lines gia na ta topothetisw sto fyllo
		obj = pooler.get_pool(cr.dbname).get('hospital.lab.line')
		str_ids=str(test_ids).replace('[','(').replace(']',')').replace(' ','')
		line_ids=obj.search(cr, uid, [('labtest_id', 'in',tuple(test_ids))])
		#print line_ids
		lines=pooler.get_pool(cr.dbname).get('hospital.lab.line').browse(cr, uid, line_ids)
		
		emp_xml=''
		added_lines=[]
		for b,l in enumerate(lines):
			if l.labelement_id.name not in added_lines:
				added_lines.append(l.labelement_id.name)
				try:units=str(l.units) if l.units else ''
				except: print l.units
				emp_xml+='<employee id="%s" name="%s" mm="%s" nval="%s">' % (b,l.labelement_id.name,units,l.normalvalues) #edw pernaw ta gnorismata tis kathe seiras
				for i in range(len(vals)): #diatrexw ta labtests
					if vals[i].has_key(l.labelement_id.id): #vlepw an yparxei timh toy sygkekrimenou gnwrismatos sto trexwn labtest
						emp_xml+='<time-element date="'+str(i+1)+'">'
						if vals[i][l.labelement_id.id]:
							emp_xml+='<amount>%s</amount>' % (vals[i][l.labelement_id.id])
							new_len = len(str(vals[i][l.labelement_id.id].encode('utf-8')))/8
							if cols[i+1] < new_len: cols[i+1]=new_len 
						else:
							pass #den exei to ergastiriako ayto ti sygkekrimeni imerominia
							#emp_xml+='<amount>-</amount>'
						emp_xml+='</time-element>'
				if l.normalvalues:
					emp_xml+='<time-element date="560"><amount>%s</amount></time-element>' % (int(str(l.normalvalues.split('-')[0].split('.')[0])))
					emp_xml+='<time-element date="561"><amount>%s</amount></time-element>' % (int(str(l.normalvalues.split('-')[1].split('.')[0])))
				emp_xml+='</employee>'
			#print l.labelement_id.name
		#print emp_xml
		values = pooler.get_pool(cr.dbname).get('hospital.lab.line').read(cr, uid,line_ids)
		#print values
		# Computing the dates (start of month: som, and end of month: eom)
		#som = datetime.date(data['form']['year'], data['form']['month'], 1)
		#eom = som + datetime.timedelta(lengthmonth(som.year, som.month))
		#date_xml = ['<date month="%s" year="%d" />' % (self.get_month_name(cr, uid, som.month), som.year), '<days>']
		
		
		#date_xml += ['<day number="%d" name="%s" weekday="%d" />' % (x, self.get_weekday_name(cr, uid, som.replace(day=x).weekday()+1), som.replace(day=x).weekday()+1) for x in range(1, lengthmonth(som.year, som.month)+1)]
		#date_xml.append('</days>')
		#date_xml.append('<cols>2.5cm%s,2cm</cols>\n' % (',0.7cm' * lengthmonth(som.year, som.month)))
		cols2=[","+str(ch)+"cm" for ch in cols[1:-1]]
		cols2.insert(0,cols[0])
		cols2.append(cols[len(cols)-1])
		cols2=''.join(cols2)
		date_xml=dates+cols2
		'''
		emp_xml=''
		for id in data['form']['user_ids'][0][2]:
			emp_xml += emp_create_xml(cr, id, som, eom)'''
		#print emp_xml
		# Computing the xml
		#Without this, report don't show non-ascii characters (TO CHECK)
		#date_xml = '\n'.join(date_xml)

		xml='''<?xml version="1.0" encoding="UTF-8" ?>
		<report>
		%s
		%s
		</report>
		''' % (date_xml, emp_xml)
		#print xml
		return xml

report_custom('report.hospital.lab_progress', 'hospital.patient', '', 'addons/hospital/report/lab_progress.xsl')

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

